<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Connect</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>Agentless Salt</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="5">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/ssh/index.html">Introduction</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/ssh/system.html">Install Salt SSH</a>
                </li>
                
                
                
                <li class="progtrckr-done">Connect</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/ssh/remotex.html">Remote Execution</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/ssh/states.html">Apply States</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Connect</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Create a Salt roster file with connection details</li>
                    
                    <li class="progtrckr-done">Connect to a remote system and run a command</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 10 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <p>Let’s learn how Salt SSH stores connection details and connects to agentless systems.</p>
<h2 id="roster-file">Roster File</h2>
<div class="section sidebar">
<h4 id="extending-the-roster">Extending the Roster</h4>
<p>As is common in Salt, the roster system can be extended. You can currently use any of the following data sources to populate the Salt roster:</p>
<ul>
<li><a href="https://docs.saltstack.com/en/latest/ref/roster/all/salt.roster.ansible.html#module-salt.roster.ansible">ansible</a></li>
<li><a href="https://docs.saltstack.com/en/latest/ref/roster/all/salt.roster.cache.html#module-salt.roster.cache">cache</a></li>
<li><a href="https://docs.saltstack.com/en/latest/ref/roster/all/salt.roster.cloud.html#module-salt.roster.cloud">cloud</a></li>
<li><a href="salt.roster.clustershell">clustershell</a></li>
<li><a href="https://docs.saltstack.com/en/latest/ref/roster/all/salt.roster.flat.html#module-salt.roster.flat">flat (default)</a></li>
<li><a href="https://docs.saltstack.com/en/develop/ref/roster/all/salt.roster.range.html#module-salt.roster.range">range (in development)</a></li>
<li><a href="https://docs.saltstack.com/en/latest/ref/roster/all/salt.roster.scan.html#module-salt.roster.scan">scan</a></li>
</ul>
<p>This guide uses the flat file roster.</p>
</div>
<p>By default, Salt uses a YAML file to store connection details for agentless systems, called the roster. A basic roster file contains an ID, a host, and a user:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">ID:</span>
  <span class="fu">host:</span> <span class="kw">[</span>IP or DNS name<span class="kw">]</span> 
  <span class="fu">user:</span> <span class="kw">[</span>username<span class="kw">]</span></code></pre>
<p>The default location of the roster file is <code>/etc/salt/roster</code>. You can use the <code>--roster-file=</code> argument (example below) to specify a different path if you want to save it somewhere else.</p>
<p>There are many additional options available in rosters, see <a href="https://docs.saltstack.com/en/develop/topics/ssh/roster.html#how-rosters-work">How Rosters Work</a> for more details.</p>
<h2 id="command-basics">Command Basics</h2>
<p>The <code>salt-ssh</code> command is used to connect to agentless systems. This command is very similar to the <code>salt</code> command:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-ssh</span> [target] [command] [arguments]</code></pre>
<p>The main difference is that any system specified in the target must be defined in the roster file, and targets can be matched using globs or regex only.</p>
<h2 id="initial-connection">Initial Connection</h2>
<p>The first time you connect to a system, Salt SSH returns a message with the key fingerprint. You can examine this key fingerprint, and then connect using the <code>-i</code> option to accept the key.</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-ssh</span> -i <span class="st">&#39;*&#39;</span> test.ping
<span class="kw">Permission</span> denied for host managed, do you want to deploy the salt-ssh key? (password required)<span class="kw">:</span>
[<span class="kw">Y</span>/<span class="kw">n</span>] y
<span class="kw">Password</span> for vagrant@managed:
<span class="kw">managed</span>:
    <span class="kw">True</span></code></pre>
<p>Salt SSH generated a local SSH RSA key to use for authentication. The user password is required the first time to deploy the key, then subsequent connections work without providing the user password:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-ssh</span> <span class="st">&#39;*&#39;</span> disk.usage 
<span class="kw">managed</span>:
    <span class="kw">----------</span>
    /:
        <span class="kw">----------</span>
        <span class="kw">1K-blocks</span>:
            <span class="kw">41251136</span>
        <span class="kw">available</span>:
            <span class="kw">38318832</span>
        <span class="kw">capacity</span>:
            <span class="kw">4%</span>
        <span class="kw">filesystem</span>:
            <span class="kw">/dev/sda1</span>
        <span class="kw">used</span>:
            <span class="kw">1196392</span>
    /dev:
        <span class="kw">----------</span>
        <span class="kw">1K-blocks</span>:
            <span class="kw">245916</span>
        <span class="kw">available</span>:
            <span class="kw">245904</span>
        <span class="kw">capacity</span>:
            <span class="kw">1%</span>
        <span class="kw">filesystem</span>:
            <span class="kw">udev</span>
        <span class="kw">used</span>:
            <span class="kw">12</span>
<span class="kw">...</span></code></pre>
<hr />
<div class="tutorial">
<h2 id="tutorial---create-a-roster-file-and-connect">Tutorial - Create a Roster File and Connect</h2>
<p>Let’s add a roster file and then run a test command. Make sure you are in the Salt SSH directory that you created previously (<code>~/salt-ssh</code>) and you have activated the virtual environment (<code>source venv/bin/activate</code>).</p>
<ol>
<li><p>Create a <code>salt-ssh/roster</code> text file and save connection details for each agentless system:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">managed:</span>
  <span class="fu">host:</span> 192.168.70.11
  <span class="fu">user:</span> vagrant</code></pre>
<p>You can add as many systems as you like to this file using this format. The example above is based on the vagrant demo systems from the previous section, but you can easily substitute the values from your own environment.</p></li>
<li><p>Create a <code>salt-ssh/Saltfile</code> text file and add connection options:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">salt-ssh:</span>
  <span class="fu">roster_file:</span> /home/vagrant/salt-ssh/roster <span class="co"># replace &#39;vagrant&#39; with your username if needed</span>
  <span class="fu">config_dir:</span> /home/vagrant/salt-ssh
  <span class="fu">log_file:</span> /home/vagrant/salt-ssh/log.txt  </code></pre>
<p>A <a href="https://docs.saltstack.com/en/latest/topics/ssh/#define-cli-options-with-saltfile">Saltfile</a> lets you specify command line options that you want included each time you run a command.</p></li>
<li><p>Test the connection by running the following command:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-ssh</span> -i <span class="st">&#39;*&#39;</span> test.ping</code></pre></li>
</ol>
<p>If all goes well you’ll get a response from each system.</p>
</div>


            <br>
            
            <a href="/en/getstarted/ssh/system.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/ssh/remotex.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>



<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>